# -*- coding: utf-8 -*-

from rest_framework import viewsets
from rest_framework.decorators import action

from thx.api.views import ThuxViewMixin
from thx.role.core.views import ThuxRoleViewSetMixin
from . import serializers
from ... import models


# BANK
class BankViewSet(ThuxRoleViewSetMixin, ThuxViewMixin, viewsets.ModelViewSet):
    queryset = models.Bank.objects.all()
    serializer_class = serializers.BankSerializer

    @action(methods=['patch'], detail=True)
    def enable(self, request, **filters):
        return super().partial_update(request)

    @action(methods=['patch'], detail=True)
    def disable(self, request, **filters):
        return super().partial_update(request)


# BANK DETAIL
class BankDetailViewSet(ThuxRoleViewSetMixin, ThuxViewMixin, viewsets.ModelViewSet):
    queryset = models.BankDetail.objects.all()
    serializer_class = serializers.BankDetailSerializer

    @action(methods=['patch'], detail=True)
    def enable(self, request, **filters):
        return super().partial_update(request)

    @action(methods=['patch'], detail=True)
    def disable(self, request, **filters):
        return super().partial_update(request)
